



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>挖一挖C#中那些我们不常用的东西之系列（5）——FlagAttribute</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">挖一挖C#中那些我们不常用的东西之系列（5）——FlagAttribute</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 07:32:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　说到FlagsAttribute，源自前几天看到了一小段代码，大概意思就是根据航班政策来返回哪些配送方式是否可用，根据这些是否可用</p>
<p>来隐藏或者开启界面的相关配送方式，如果大家订过机票可能知道配送方式有很多种，比如&ldquo;无需打印行程单（PJN）&rdquo;，&ldquo;机场自取(Airport)&rdquo;，</p>
<p>&ldquo;市内配送(CND)&rdquo;，&ldquo;快递(EMS)&rdquo;等等。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/214741/201406/291749168046823.png" /></p>
<p>根据上面的逻辑就可以知道，配送方式是有两种状态，可用与不可用，在逻辑实现上，很容易就想到了bit位，每一个位代表一个配送方式，</p>
<p>0表示不可用，1表示可用，所以航班接口只要给一个数字就行了，我只需要判断bit位中哪些是1就行了。</p>
<p>比如用8位byte字段为例：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/214741/201406/291829135547977.png" /></p>
<p>从图中可以看到，快递（EMS）是不可用的，那么怎么判断呢，其实也就17&amp;32就ok了，如果为32，则说明可用，为0则不可用，其他</p>
<p>的判断可以用同样的手段。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/214741/201406/291815382116384.png" /></p>
<p>上次看到的代码逻辑就这样了，不过毕竟在一个团队里面，水平参差不齐，用纯数字来&amp;，|,^，最起码不是那么容易理解的，如果</p>
<p>配上枚举的话，可能就更完美了。</p>
<p>说起枚举，其实就是编译器给我们的语法糖，本质上来说就是一个继承在Enum类型下的一个个const字段，既然是const，那</p>
<p>就天生具备（+，-，* ,/ ^,| &amp;）这样常规的数学运算。</p>
<p>举个例子：</p>
<div>
<pre class="prettyprint linenums">     [Flags]<br />
     enum Deliver : byte<br />
     {<br />
         CND = 0x01,<br />
         PJS = 0x02,<br />
         SND = 0x04,<br />
         PJN = 0x08,<br />
         Airport = 0x16,<br />
         EMS = 0x32<br />
     }</pre>
</div>
<p>然后看看上面的Enum生成的IL代码。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/214741/201406/291841434922620.png" /></p>
<p>可能有人会问，这里的&ldquo;uint8&rdquo; 是怎么回事，其实这个就是隐藏到枚举类型后面的真实的基元类型，可以用GetUnderlyingType来获取。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/214741/201406/291845402738125.png" /></p>
<p>通常情况下，枚举只能显示一个状态，那么如果让枚举显示多个状态，这个时候就可以用FlagAttribute来标记，让标志位来处理枚举，</p>
<p>来做强大的组合功能。</p>
<p>举个例子：从图中航班政策返回的17的数字来看，我们知道Airport和CND是可用的，如果用了FlagAttribute标记后，这次我们不用担</p>
<p>心，直接将17转化为枚举即可。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/214741/201406/291906226012764.png" /></p>
<p>从图中看到，经过枚举转换后，可能对程序员的理解以及记录log上面，更方便分析和追踪。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxy4j9y.html">Linux学习日记&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxn4mv8.html">web前端面试总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwdg5y8.html">mybatis generator&period;xml  配置 自动生成model&comma;dao&comma;mapping</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1yrp5q.html">make&colon; Nothing to be done for &grave;first&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn640k9.html">【前台   submit的重复提交  错误】submit的重复提交</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k6grrq.html">HDOJ-1002</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m33x29.html">spark&period;SecurityManager&colon; SecurityManager&colon; authentication disabled</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvx6kj8.html">Edmond&lowbar;Karp算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15wj69.html">查看linux系统版本命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yo6kw8.html">2080夹角有多大II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljon2k9.html">MFC通过ODBC连接Mysql程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzev148.html">viewpager处理（三）：让viewpager不预加载下一页</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y2djz8.html">操作系统 - unix和windows下进程异同</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pw4wy8.html">Java多线程 阻塞队列和并发集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4je7znq.html">Vue Router的懒加载路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj3z269.html">python短信发送</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oprrx8.html">UWP开发细节记录：WRL&colon;&colon;ComPtr 的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pzme3q.html">ios（包括6、7）应用程序引用系统通讯录的方法 ［亲测可行］</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ppoz08.html">【Socket】linux无连接编程技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn0x37q.html">Apache mod&lowbar;rewrite实现HTTP和HTTPS重定向跳转</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq43w6n8.html">onblur鼠标失去焦点事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/4957l0zq.html">Python语言and-or的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p26yd8.html">Scalaz（12）－ Monad：再述述flatMap，顺便了解MonadPlus</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1wo759.html">《Java4android》视频学习笔记&mdash;&mdash;面向对象的应用（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q701ee8.html">指针，&amp;amp&semi;的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rk247q.html">jdbc应用程序连接Oracle rac的URL写法：</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4302j8.html">给你推荐10款优秀的 HTML5 动画工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw43nl8.html">javascript对象继承详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8erzkkq.html">css小技巧，会不断更新的</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdr6pz8.html">Sharepoint学习笔记&mdash;习题系列--70-576习题解析 -&lpar;Q59-Q62&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
